#include <Application.h>
#include <Button.h>
#include <GroupLayout.h>
#include <InterfaceDefs.h>
#include <Menu.h>
#include <MenuBar.h>
#include <MenuItem.h>
#include <Message.h>
#include <Rect.h>
#include <Window.h>


class App : public BApplication {
public:
	App();
	~App();

protected:
	void ReadyToRun();
	bool QuitRequested();
};


App::App()
	:
	BApplication("application/x-vnd.Haiku-MenuTester")
{
}


App::~App(void)
{
}


void
App::ReadyToRun()
{
	BWindow* window = new BWindow(BRect(100, 100, 400, 200), "menu tester window",
		B_TITLED_WINDOW, B_NOT_ZOOMABLE | B_NOT_RESIZABLE | B_AUTO_UPDATE_SIZE_LIMITS);
	window->SetLayout(new BGroupLayout(B_VERTICAL, B_USE_DEFAULT_SPACING));

	BMenuBar* menuBar = new BMenuBar("menu bar");
	BMenu* fileMenu = new BMenu("File");
	BMenuItem* closeItem = new BMenuItem("close", new BMessage(B_QUIT_REQUESTED));
	fileMenu->AddItem(closeItem);
	menuBar->AddItem(fileMenu);

	BMenu* editMenu = new BMenu("Edit");
	BMenuItem* cutItem = new BMenuItem("cut", new BMessage(B_CUT));
	editMenu->AddItem(cutItem);
	BMenuItem* copyItem = new BMenuItem("copy", new BMessage(B_COPY));
	editMenu->AddItem(copyItem);
	BMenuItem* pasteItem = new BMenuItem("paste", new BMessage(B_PASTE));
	editMenu->AddItem(pasteItem);
	menuBar->AddItem(editMenu);

	window->GetLayout()->AddView(menuBar);

	BButton* closeWindowButton = new BButton("close", "Close Window",
		new BMessage(B_QUIT_REQUESTED));
	closeWindowButton->SetTarget(this);

	window->GetLayout()->AddView(closeWindowButton);

	window->Show();
}


bool
App::QuitRequested()
{
	snooze(1000000);
	return true;
}


int
main(void)
{
	App app;
	app.Run();

	return 0;
}
